package eu.jonahbauer.json.exceptions;

import lombok.Getter;
import org.jetbrains.annotations.NotNull;

@Getter
abstract class JsonReaderException extends JsonProcessingException {
    private final int lineNumber;
    private final int columnNumber;

    public JsonReaderException(int line, int column, @NotNull String message) {
        super(message);
        this.lineNumber = line;
        this.columnNumber = column;
    }

    public JsonReaderException(int line, int column, @NotNull String message, @NotNull Throwable cause) {
        super(message, cause);
        this.lineNumber = line;
        this.columnNumber = column;
    }

    @Override
    public @NotNull String getMessage() {
        return super.getMessage() + " at line " + getLineNumber() + ", column " + getColumnNumber();
    }
}
